Package com.saxonica.ee.stream.feed

## Class TypedValueFeed

- java.lang.Object
- - net.sf.saxon.event.Outputter
  - - net.sf.saxon.event.ProxyOutputter
    - - com.saxonica.ee.stream.feed.ItemFeed
      - - com.saxonica.ee.stream.feed.GroundedItemFeed
        - - com.saxonica.ee.stream.feed.AbsorptionFeed
          - - com.saxonica.ee.stream.feed.TypedValueFeed

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`

      public class TypedValueFeed
      extends AbsorptionFeed

  This class is used when a streamed template requests evaluation of the typed value of the nodes selected by a path expression.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.saxonica.ee.stream.feed.AbsorptionFeed

      `AbsorptionFeed.PendingItem`

  - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.Outputter

      `pipelineConfiguration, systemId`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TypedValueFeed​(ItemFeed result, XPathContext context)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `attribute​(NodeName attName, SimpleType typeCode, java.lang.CharSequence value, Location location, int properties)` | Notify an attribute.
    `void` | `characters​(java.lang.CharSequence chars, Location location, int properties)` | Notify character data.
    `void` | `comment​(java.lang.CharSequence content, Location location, int properties)` | Notify a comment.
    `void` | `endDocument()` | Notify the end of a document node
    `void` | `endElement()` | Notify the end of an element.
    `protected AbsorptionFeed.PendingItem` | `makePendingItem​(int sequenceNr, FleetingParentNode node)` | Create a pending item (appropriate to the subclass) containing the data needed to compute the result value for one node in the streamed input sequence
    `void` | `namespace​(java.lang.String prefix, java.lang.String namespaceUri, int properties)` | Notify a namespace binding.
    `protected Sequence` | `processGroundedItem​(Item item)` | Process a grounded item in the input sequence: either a streamed leaf node such as an attribute or text node, or an atomic value, or a non-streamed element or document node injected into the sequence for example by use of the comma operator.
    `void` | `processingInstruction​(java.lang.String name, java.lang.CharSequence data, Location location, int properties)` | Output a processing instruction
    `void` | `startContent()` | Notify the start of the content, that is, the completion of all attributes and namespaces.
    `void` | `startDocument​(int properties)` | Notify the start of a document node
    `void` | `startElement​(NodeName elemName, SchemaType type, AttributeMap attributes, NamespaceMap namespaces, Location location, int properties)` | Notify the start of an element, supplying all attributes and namespaces
    `void` | `startElement​(NodeName elemName, SchemaType typeCode, Location location, int properties)` | Notify the start of an element

    - ### Methods inherited from class com.saxonica.ee.stream.feed.AbsorptionFeed

      `append, endSelectedParentNode, setHasFailed, startSelectedParentNode`

    - ### Methods inherited from class com.saxonica.ee.stream.feed.GroundedItemFeed

      `setUnparsedEntity`

    - ### Methods inherited from class com.saxonica.ee.stream.feed.ItemFeed

      `append, close, dynamicError, getContext, getExpression, getResult, getTerminator, hasFailed, open, processItems, setExpression, setTerminator`

    - ### Methods inherited from class net.sf.saxon.event.ProxyOutputter

      `getNextOutputter, open, setLocation, usesTypeAnnotations`

    - ### Methods inherited from class net.sf.saxon.event.Outputter

      `getConfiguration, getPipelineConfiguration, getStringReceiver, getSystemId, namespaces, setPipelineConfiguration, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `handlesAppend`

- - ### Constructor Detail

    - #### TypedValueFeed

          public TypedValueFeed​(ItemFeed result,
                                XPathContext context)

  - ### Method Detail

    - #### makePendingItem

          protected AbsorptionFeed.PendingItem makePendingItem​(int sequenceNr,
                                                               FleetingParentNode node)

      Description copied from class: `AbsorptionFeed`
      Create a pending item (appropriate to the subclass) containing the data needed to compute the result value for one node in the streamed input sequence
      Specified by:
        `makePendingItem` in class `AbsorptionFeed`
      Parameters:
        `sequenceNr` - the sequence number of this node within a set of nested nodes
        `node` - the streamed input node
      Returns:
        the data needed to process this node

    - #### processGroundedItem

          protected Sequence processGroundedItem​(Item item)
                                          throws XPathException

      Description copied from class: `AbsorptionFeed`
      Process a grounded item in the input sequence: either a streamed leaf node such as an attribute or text node, or an atomic value, or a non-streamed element or document node injected into the sequence for example by use of the comma operator.
      Specified by:
        `processGroundedItem` in class `AbsorptionFeed`
      Parameters:
        `item` - the grounded item
      Returns:
        the result of processing the grounded item
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### startDocument

          public void startDocument​(int properties)
                             throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the start of a document node
      Specified by:
        `startDocument` in interface `Receiver`
      Overrides:
        `startDocument` in class `GroundedItemFeed`
      Parameters:
        `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### endDocument

          public void endDocument()
                           throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the end of a document node
      Specified by:
        `endDocument` in interface `Receiver`
      Overrides:
        `endDocument` in class `GroundedItemFeed`
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType typeCode,
                                   Location location,
                                   int properties)
                            throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the start of an element
      Overrides:
        `startElement` in class `GroundedItemFeed`
      Parameters:
        `elemName` - the name of the element.
        `typeCode` - the type annotation of the element.
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType type,
                                   AttributeMap attributes,
                                   NamespaceMap namespaces,
                                   Location location,
                                   int properties)
                            throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the start of an element, supplying all attributes and namespaces
      Specified by:
        `startElement` in interface `Receiver`
      Overrides:
        `startElement` in class `GroundedItemFeed`
      Parameters:
        `elemName` - the name of the element.
        `type` - the type annotation of the element.
        `attributes` - the attributes of this element
        `namespaces` - the in-scope namespaces of this element: generally this is all the in-scope namespaces, without relying on inheriting namespaces from parent elements
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### namespace

          public void namespace​(java.lang.String prefix,
                                java.lang.String namespaceUri,
                                int properties)
                         throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify a namespace binding. This method is called at some point after startElement(). The semantics are similar to the xsl:namespace instruction in XSLT, or the namespace node constructor in XQuery. A namespace must not conflict with any namespaces already used for element or attribute names.
      Overrides:
        `namespace` in class `GroundedItemFeed`
      Parameters:
        `prefix` - The namespace prefix; zero-length string for the default namespace
        `namespaceUri` - The namespace URI. In some cases a zero-length string may be used to indicate a namespace undeclaration.
        `properties` - The REJECT_DUPLICATES property: if set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:
      Throws:
        `XPathException` - if an error occurs

    - #### attribute

          public void attribute​(NodeName attName,
                                SimpleType typeCode,
                                java.lang.CharSequence value,
                                Location location,
                                int properties)
                         throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.
      Overrides:
        `attribute` in class `GroundedItemFeed`
      Parameters:
        `attName` - The name of the attribute
        `typeCode` - The type annotation of the attribute
        `value` - the string value of the attribute
        `location` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this attribute
        NO_SPECIAL_CHARACTERS
          Attribute value contains no special characters
      Throws:
        `XPathException` - if an error occurs

    - #### startContent

          public void startContent()

      Description copied from class: `ProxyOutputter`
      Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial Outputter of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.
      Overrides:
        `startContent` in class `GroundedItemFeed`

    - #### endElement

          public void endElement()
                          throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify the end of an element. The Outputter must maintain a stack if it needs to know which element is ending.
      Specified by:
        `endElement` in interface `Receiver`
      Overrides:
        `endElement` in class `GroundedItemFeed`
      Throws:
        `XPathException` - if an error occurs

    - #### characters

          public void characters​(java.lang.CharSequence chars,
                                 Location location,
                                 int properties)
                          throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify character data. Note that some receivers may require the character data to be sent in a single event, but in general this is not a requirement.
      Specified by:
        `characters` in interface `Receiver`
      Overrides:
        `characters` in class `GroundedItemFeed`
      Parameters:
        `chars` - The characters
        `location` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this text node
        USE_CDATA
          Output as a CDATA section
      Throws:
        `XPathException` - if an error occurs

    - #### processingInstruction

          public void processingInstruction​(java.lang.String name,
                                            java.lang.CharSequence data,
                                            Location location,
                                            int properties)
                                     throws XPathException

      Description copied from class: `ProxyOutputter`
      Output a processing instruction
      Specified by:
        `processingInstruction` in interface `Receiver`
      Overrides:
        `processingInstruction` in class `GroundedItemFeed`
      Parameters:
        `name` - The PI name. This must be a legal name (it will not be checked).
        `data` - The data portion of the processing instruction
        `location` - provides information such as line number and system ID.
        `properties` - Additional information about the PI.
      Throws:
        `XPathException` - if an error occurs

    - #### comment

          public void comment​(java.lang.CharSequence content,
                              Location location,
                              int properties)
                       throws XPathException

      Description copied from class: `ProxyOutputter`
      Notify a comment. Comments are only notified if they are outside the DTD.
      Specified by:
        `comment` in interface `Receiver`
      Overrides:
        `comment` in class `GroundedItemFeed`
      Parameters:
        `content` - The content of the comment
        `location` - provides information such as line number and system ID.
        `properties` - Additional information about the comment.
      Throws:
        `XPathException` - if an error occurs